PROGRAM main
!
     use mpi
     implicit none
     integer, parameter :: filesize=8 !# of elements..
!
     integer buf(filesize)
     integer rank,ierr,fh,nprocs,nints,intsize,count,i
     integer status(MPI_STATUS_SIZE)
     integer(kind=MPI_OFFSET_KIND) offset
!
! mpi stuff
     call MPI_INIT(ierr)
     call MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
     call MPI_COMM_SIZE(MPI_COMM_WORLD,nprocs,ierr)
     call MPI_TYPE_SIZE(MPI_INTEGER,intsize,ierr)
!
! set #of elements for task
     count=filesize/nprocs
!
! set file offset for task
     offset=rank*count*intsize
!
! initialize vector
     do i=1, count
        buf(i) = -1
     enddo
!
     write(6,*) "Task ", rank, " read from ", offset, "elements ", count
!
     call MPI_FILE_OPEN(MPI_COMM_WORLD,'out.bin',MPI_MODE_RDONLY,MPI_INFO_NULL,fh,ierr) 
     if(ierr == 0) then
        write(6,*) "file exists....."
     else
        write(6,*) "Huston we have a problem!"
        call MPI_FINALIZE(ierr)
     endif
!
     call MPI_FILE_READ_AT(fh,offset,buf,count,MPI_INTEGER,status,ierr)
!
! check
     write(6,*) "Fist number read from task", rank, buf(1)
!
     call MPI_FILE_CLOSE(fh,ierr)
     call MPI_FINALIZE(ierr)
END PROGRAM main
